Project Euler's 500th problem
projecteuler.net
projecteuler.net
Alternating between project Euler, a book (or two), back to project Euler for a bit is a very fast school, and you determine how fast you can pace yourself.
Not to cheat using Google, but to discover the name of the branch of mathematics I had no clue about, and then to learn enough to keep going.
I still remember the afternoon I spent doing chromatic polynomials by hand, each graph I drew having more mental exclamations on the end, because I was goddamn getting it.
For me, the lift from earning a right answer is palpable.
https://projecteuler.net/problem=307
I couldn't solve it analytically for the life of me. So I wrote a small simulator, computed the answer to within 7 decimal places or so and then tried to figure out why that was the right answer. Then the lightbulb went on and I realized what the real answer should be and it worked.
As I wrote above, I am not very good at math, but to be able to use the computer to make your math understanding better than what it was before you started solving a problem was a huge up for me.
Anyone else feel similarly?
Yes, a lot of the problems can be done by hand. You could treat the problems as "a math problem to solve", or as "an exercise in solving a problem with software."
When you've solved a problem, you have either "obtained the correct answer," or you have "figured out how to obtain the correct answer with software." Or both.
For me, even solving the early trivial ones, that could be done by hand, are more an exercise in software than in math.
Most of the time, I try to write my solutions in a general way, so that I can change the parameters of the problem, run it through software I've already written, and get the right results. The challenge then is defining the boundaries and parameters, and imagining the possible and reasonable limits of those boundaries and parameters. Just like we do every day with the rest of our software challenges.
The fact that these are math problems make it more fun for me, because I am not at all mathematically inclined. So I have to learn a little more math, and then decide if I've learned it sufficiently that my solution is reasonable.
Reading other people's posted solutions is almost as fun as solving the puzzle. I've learned a lot, or at least been impressed, from the various languages and hand solutions.
As for learning a new language, I think Euler is a reasonable tool in the total box. I find that I don't really know a new language until I've struggled with something "real" that matters, to me or my employer. And even then, if I come back to code a year or two later, I sometimes cringe, since I've likely learned more about using the language's strengths in that time, beyond just writing C in a new language.
I'm currently trying to learn Rust, and since it's so new everything is geared towards people with experience. So I started Rust For Beginners:
http://www.rustforbeginners.com
I'm trying to make it a guide to the language, and programming in general, for true beginners. The very first post of actual coding (after installing, command line basics, and compiling/running with cargo) is a walk through of the first PE problem.
I know how you feel about most beginners guides not actually being suited for beginners. Since I'm a beginner, I'm hoping I'll be able to write one.
Feel free to check it out, and constructive criticism is encouraged!
The great thing about Project Euler for this is that the correct answer isn't a piece of code or an algorithm in some language, but just a number.
Project Euler does not really care how that number was derived. Using a mathematical formula, plain pencil and paper, a program in some language, or cheating via Google-fu? Euler doesn't care.
Because of this, it is very inviting to code a solution in a different language: 1) to learn that language, 2) to use a concept of the language with a better fit with the problem, 3) to see which language yields the quickest answer, measured in development time or actual run time.
The drawback of Project Euler is that it's quite addictive.
We invite all members to participate in our problem solving party. As celebrator of this jubilee we're allowed to ask the participants for a present. Well, here's our wish: please don't share any information about our party and the dishes we're serving you outside the fora dedicated to our dishes after your meal. This to allow those that are late to the party to consume our dishes undisturbed by premature revelations about what we are serving."
Also suitable for learning new languages (and bioinformatics).
The implementation of the site is awesome.
The instructors also created a course on Coursera called "Bioinformatics Algorithms" that I highly recommend. It's basically an ordered set of rosalind problems but accompanied by a textbook and lectures. It was one of the most interesting things I did last year.
To expand a bit, what I liked about the course was the textbook, algorithms and their practical application in a non-CS field with a good set of programming problems that are automatically assessed.
And it's an effective teacher because those problems are arranged like the programs in the ORIC-1's manual, in what Hughes calls an "inductive chain":
The problems range in difficulty and for many the experience is inductive chain learning. That is, by solving one problem it will expose you to a new concept that allows you to undertake a previously inaccessible problem. So the determined participant will slowly but surely work his/her way through every problem.
[1]http://www.theatlantic.com/technology/print/2011/06/how-i-fa...
If I could do one thing to augment the project I would make it possible to filter previous solutions by language and/or author.
For example, if I'm learning rust, I would love to see all the rust solutions right there together.
If you've never tried Project Euler, it's a great way to learn new mathematical concepts, sequences, dynamic programming and other algorithms.
https://projecteuler.net/problem=368 was one of my favorites, because it involved turning an algorithm described in a paper into code.
I don't consider this a spoiler for problem #500, but if you're counting the number of divisors, you'll need this function: http://oeis.org/wiki/Number_of_divisors_function#Formulae_fo...
As an example, 120 = 2^3 * 3^1 * 5^1
number of divisors of 120 => (3+1)(1+1)(1+1)
Even if you don't solve it, exploring the problem is a fun afternoon for a person with a computer.
but the sum of the reciprocals of the primes is roughly proportional to log(log(n)). That's a crazy slow divergence.
H(n) = 1/1 + 1/2 + ... + 1/n
H_2(n) = 1 / (H(1)) + 1 / (2 H(2)) + 1 / (3 H(3)) + ... + 1 / (n H(n))
H_3(n) = 1 / (H(1) H_2(1)) + 1 / (2 H(2) H_2(2)) + 1 / (3 H(3) H_2(3)) + ... + 1 / (n H(n) H_2(n))
...
H_k(n) = 1 / (H(1) H_2(1) ... H_{k-1}(1)) + 1 / (2 H(2) H_2(2) ... H_{k-1}(2)) + ... + 1 / (n H(n) H_2(n) ... H_{k-1}(n))
The series H_k(n) diverges roughly proportional to log(log(... k logs ... (log(n)) ...)).
We have:
sum (up to n) of 1/x ~= log n [harmonic series]
sum (up to n) of 1/(x log x) ~= log log n [reciprocals of primes, roughly]
sum (up to n) of 1/(x log x log log x) ~= log log log n
and so on. All these series diverge, but slower and slower and slower. And clearly these series "only just" diverge. In fact, iIf you take, e.g.,
sum of 1/(x log x log log x (log log log x)^1.1)
then it converges. If you have just the right kind of warped mind, the question that will immediately occur to you on contemplating this is: what if you define L(x) := x log x log log x log log log x ... continuing the product up to, but excluding, the first factor that's < 1, and ask about the sum of 1/L(x)?
Answer: The series diverges really slowly. The points at which L(x) starts to use one extra logarithm are e, e^e, e^e^e, e^e^e^e, etc. The sums between each adjacent pair of these are comparable in size. So the sum up to n is roughly the number of times you need to take logs, starting with n, before you get down to 1.
[EDITED to add: The first bit of the above is closely related to cperciva's comment that's a sibling of this one.]
Any chance you guys know of a similar project for Computer Vision or general AI topics?
For those of us who are familiar with TopCoder, CodeForces or, perhaps, ACM ICPC, this should be daily bread and butter on prime numbers and data structures :)
Here is my solution if you are curious: https://gist.github.com/Slava/74276f5b7889a1d68a71 - computes the result in 400ms
Edit: hah, looking at the problems discussion board I took a very bruteforce approach, other people solved utilizing math, I used priority_queue for no particular reason :)
Congrats to Project Euler on their 500th problem!
I solved 50 of them, I usually use Java, or Mathematica which feels...cheaty but sometimes all it takes is a paper and a pencil.
--------- MAJOR SPOILERS ---------
Let's multiply unique prime numbers and count their factors.
n Number of factors
2 2 (1, 2)
2x3 4 (1, 2, 3, 6)
2x3x5 8
2x3x5x7 16
Notice that each time you add a new prime number, the factor count doublesi.e. 2x3x5x...x500500th prime will have 2^500500 factors
The 500500th prime is 7376507 (thanks to wolframalpha), and it's not very big.
We can easily get the product of the above with 500500 multiplications while modding result of each step by 500500507 to get an answer.
Except that the product of first 500500 primes isn't the smallest number containing 2^500500 factors. This can be made smaller.
Observe that
(2x3x5x...x500499th prime)x2
has 2^500499 + 2^500498 factors.
This is because with the extra 2 we added, it produces additional factors with existing factors that are a multiples of 2.Continuing with this, we see that
(2x3x5x...x500499th prime) x (2 x 2)
has 2^500499 + 2^500498 + 2^500498 = 2^500500 factors.
This is a better solution, since 2x2 is smaller than the 500500th prime.If we want continue doubling factor count by multiplying 2s, we will need to multiply by 2x2x2x2 next, and 2^8 after, which becomes inefficient quickly. Instead, why not use 3? Multiplying (2x3x5x...x500499th prime) by (3 x 3) also doubles the factor count.
So at this point, we think about doubling factor count and the ways we can do it. Out options are
<1>. Multiply by a prime that we have never used so far
<2>. Multiply by an existing prime k + 1 times, where k is the number of times it has been used
We repeat this 500500 times, using rule <1> and <2> (which can be generalized to one rule) and the result is the final answer.
factor count n
2 2
4 2*3 <1>
8 2*3*2*2 <2>
16 2*3*2*2*5 <1>
32 2*3*2*2*5*7 <1>
64 2*3*2*2*5*7*3*3 <2>
128 2*3*2*2*5*7*3*3*11 <1>
For 16 factors the number works out to be 120 (just like the example!). For numbers shown in the questions, sieving the prime takes some time, I also found it helpful to use a binary heap for speeding up finding the next smallest factors.